package com.zipcodewilmington.generic.identifiables;

import java.io.*;
import java.lang.reflect.ParameterizedType;
import java.nio.charset.Charset;
import java.util.Random;

/**
 * @author leon on 05/12/2018.
 */
public class Person implements IdentifiableInterface<String> {

    private String id;

    public Person(){
       this.id = generateId();
    }

    @Override
    public String getIdentity() {
        return id;
    }

    public Class<String> getIdentityType() {
        return (Class) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0];
    }

    private String generateId(){
        byte[] array = new byte[5];
        new Random().nextBytes(array);
        return new String(array, Charset.forName("UTF-8"));
    }
}
